<?php
/**
 * browsercompatibility Plugin
 *
 * Display a pop up on the screen if the current browser is not one of the supported browsers.
 *
 */
class Pluginbrowsercompatibility extends Plugin {

	/**
	 * Constructor
	 */
	function Pluginbrowsercompatibility() {
	}

	/**
	 * Function initializes the Plugin and registers all hooks
	 */
	function init() {
		$this->registerHook('server.core.settings.init.before');
	}

	/**
	 * Function is executed when a hook is triggered by the PluginManager
	 *
	 * @param string $eventID the id of the triggered hook
	 * @param mixed $data object(s) related to the hook
	 */
	function execute($eventID, &$data) {
		switch($eventID) {
			case 'server.core.settings.init.before' :
				$this->injectPluginSettings($data);
				break;
		}
	}


	/**
	 * Called when the core Settings class is initialized and ready to accept sysadmin default
	 * settings. Registers the sysadmin defaults for the testcompatibility plugin.
	 * @param Array $data Reference to the data of the triggered hook
	 */
	function injectPluginSettings(&$data) {
		$data['settingsObj']->addSysAdminDefaults(Array(
			'zarafa' => Array(
				'v1' => Array(
					'main' => Array(
						'notifier' => Array(
							'info' => Array(
								'browsercompatibility' => Array(
									'value' => 'persistentmessageplugin'
								)
							)
						)
					),
					'plugins' => Array(
						'browsercompatibility' => Array(
							'enable' => PLUGIN_BROWSERCOMPATIBILITY_USER_DEFAULT_ENABLE
						)
					)
				)
			)
		));
	}
}
?>
